//+------------------------------------------------------------------+
//|                                                 Momentum_YTG.mq4 |
//|                                               Yuriy Tokman (YTG) |
//|                                               https://ytg.com.ua |
//+------------------------------------------------------------------+
#property copyright "Yuriy Tokman (YTG)"
#property link      "https://ytg.com.ua"
#property version   "1.00"
#property strict
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 clrGreen
#property indicator_color2 clrRed
#property indicator_width1 3
#property indicator_width2 3
#property indicator_level1 100
#property indicator_levelcolor clrBlue
#property indicator_levelwidth 2
//--- input parameter
input int MPeriod=14;//Momentum Period
//--- buffers
double BU0[],BU1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   string short_name;
   short_name="Momentum_ytg("+IntegerToString(MPeriod)+") ";
   IndicatorShortName(short_name);   
   
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,BU0);
   SetIndexLabel(0,"UP");
      
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,BU1);   
   SetIndexLabel(0,"DN");

   if(MPeriod<=0)
     {
      Print("Wrong input parameter Momentum Period=",MPeriod);
      return(INIT_FAILED);
     }
//---
   SetIndexDrawBegin(0,MPeriod);
   SetIndexDrawBegin(1,MPeriod);   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   int i,limit;
   double par =0;
   if(rates_total<=MPeriod || MPeriod<=0)return(0);
   ArraySetAsSeries(BU0,false);
   ArraySetAsSeries(BU1,false);  
   ArraySetAsSeries(close,false);

   if(prev_calculated<=0){
    for(i=0; i<MPeriod; i++){
     BU0[i]=0.0;BU1[i]=0.0;}
     limit=MPeriod;
    }
  else
   limit=prev_calculated-1;
   for(i=limit; i<rates_total; i++){
    par = close[i]*100/close[i-MPeriod];
    if(par>100)BU0[i]=par;
    else BU1[i]=par;
   }   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
